2025-03-07  Christian Gutschow <chris.g@cern.ch>

	* Release version 2.1.0

2025-03-06  Christian Gutschow <chris.g@cern.ch>

	* Add support for regex-based capture of AO path/name components
	with optional string substitution map.

2025-02-09  Christian Gutschow <chris.g@cern.ch>

	* Release version 2.0.3

2024-12-06  Andy Buckley  <andy.buckley@cern.ch>

	* Convert all scripts to use explicit python3 as interpreter, and
	remove defunct uses of 'from __future__ import' except in
	configure.ac where compatibility is needed to detect and reject
	Python2.

2024-11-08  Andy Buckley  <andy.buckley@cern.ch>

	* Add exception handling and Scatter1D conversion to YODA-to-ROOT conversion.

2024-11-06 Christian Gutschow <chris.g@cern.ch>

	* Restore case-sensitivity for Python dictionary in annotationsDict() call.

2024-10-01  Andy Buckley  <andy.buckley@cern.ch>

	* Fix typo and path-setting in yodaenvelope. Thanks to Alan Price
	for the patch.

2024-05-16  Andy Buckley  <andy.buckley@cern.ch>

	* Change Python build to use PY_LDFLAGS rather than LINKFORSHARED variable.

2023-12-15  Andy Buckley  <andy.buckley@cern.ch>

	* Fix Python path detection again, cf. GAMBIT Mac CI. Thanks to
	Chris Chang.

2023-12-05  Andy Buckley  <andy.buckley@cern.ch>

	* Enable -Wextra warnings upon recommendation from CMS, and
	address resulting issues.

2023-10-01 Christian Gutschow <chris.g@cern.ch>

	* Tagging 2.0.0alpha version with a redesigned backend,
	based on GSoc work done by Nick Rozinsky. Introduces a
	redesigned backend new set of AnalysisObjects	generalised
	to arbitrary dimensions	Requires C++17 flag.
	More detailed write-up in progress.

2023-03-02 Yoran Yeh <yoran.yeh@cern.ch>

	* Introducing matplotlib based plotting: standalone Python scripts are
	generated that contain the logic to produce a plot. These script do not
	depend on YODA and should hence be sharable with people that have no YODA.
	Python3 and matplotlib are required. The numerical data	associated with
	individual curves is outsourced to a {name}__data.py script to aide
	legibility.

2023-02-07 Christian Gutschow <chris.g@cern.ch>

	* Fix bug in yodamerge to handle files with inconsistent AOs
	Thanks to Alexander Puck Neuwirth for the report!

2022-11-02  Andy Buckley  <andy.buckley@cern.ch>

	* Add CXXFLAGS and LDFLAGS propagation to the Python-extension
	build script (thanks to Alexander Puck Neuwirth for the
	suggestion).

2022-10-12  Andy Buckley  <andy.buckley@cern.ch>

	* Enable Cython auto-conversion of all C++ strings to Python
	native str for v2 and v3, removing extensive encode()/decode()
	calls.

	* Add binreloc-based libPath() and dataPath() functions, including in Python.

2022-09-27  Andy Buckley  <andy.buckley@cern.ch>

	* Release version 1.9.7

2022-09-13  Jon Butterworth  <j.butterworth@ucl.ac.uk>

	* Add Stat and Uncor to labels flagged as uncorrelated

2022-08-18  Andy Buckley  <andy.buckley@cern.ch>

	* Update yaml-cpp version for C++17 compatibility.

2022-07-08  Andy Buckley  <andy.buckley@cern.ch>

	* Replace distutils with sysconfig and manual calls to the compiler.

2022-07-15  Andy Buckley  <andy.buckley@cern.ch>

	* Release version 1.9.6

2022-07-13  Jon Butterworth  <J.Butterworth@ucl.ac.uk>

	* Pass ignoreOffDiagonalTerms correctly when retrieving covariance matrix from a Scatter2D.

	* Add a covariance/off-diag test to test-s2d.py

2022-06-08  Max Knobbe  <max.knobbe@uni-goettingen.de>

	* Force Cython rebuilds on all .pyx files, if possible (helps with Python ABI compat).

2022-05-13  Andy Buckley  <andy.buckley@cern.ch>

	* Release version 1.9.5

2022-05-13  Chris Gutschow  <chris.g@cern.ch>

	* Add per-AO double-precision writing if the WriterDoublePrecision
	annotation is set.

2022-04-20  Andy Buckley  <andy.buckley@cern.ch>

	* Ensure that default variation +- errors are both positive, for
	all Scatter types.  Original patch by Jon Butterworth.

2022-03-28  Andy Buckley  <andy.buckley@cern.ch>

	* Protect against NaNs arising from the YAML parser in error-breakdown calcs.

2021-12-02  Andy Buckley  <andy.buckley@cern.ch>

	* Release version 1.9.4

2021-12-01  Dmitry Kalinkin <dmitry.kalinkin+hepcedar@gmail.com>

	* Fix Scatter.variations keys to be string instead of bytes in Python 3.

2021-11-24  Andy Buckley  <andy.buckley@cern.ch>

	* Release version 1.9.3

2021-11-21  Dmitry Kalinkin <dmitry.kalinkin+hepcedar@gmail.com>

	* yoda2root,root2yoda: use ROOT in the batch mode

2021-11-12  Dmitry Kalinkin <dmitry.kalinkin+hepcedar@gmail.com>

	* Restructure tests to use autotools standard naming and trigger on extensions,
	and to ensure testwriter runs before testreader.

	* Fix Point.errMap() keys to be string instead of bytes in Python 3.

2021-11-19  Andy Buckley  <andy.buckley@cern.ch>

	* Catch low-stats errors in computing errors in H1 and H2 conversion to scatters.

2021-11-12  Andy Buckley  <andy.buckley@cern.ch>

	* Fix ambiguity/bugginess in the yoda.mkScatter() unbound helper function.

2021-11-05  Andy Buckley  <andy.buckley@cern.ch>

	* Release version 1.9.2

	* Fix ao.path setting to use ao.setPath() in root2yoda. Thanks to
	Julia Yarba for the report.

2021-10-29 Christian Gutschow <chris.g@cern.ch>

	* Introduce rmVariations() for Points and Scatters

2021-10-29  Andy Buckley  <andy.buckley@cern.ch>

	* Add precision arguments to unbound write functions, and Python
	mapping of setPrecision() and useCompression() methods of Writer
	classes.

	* Fix IO failure modes to actually report exceptions, and with
	correct types and error messages.

2021-06-30  Dmitry Kalinkin <dmitry.kalinkin+hepcedar@gmail.com>

	* Fix broken reading gzipped files in Python (was a regression in
	1.9.0)

2021-08-13  Andy Buckley  <andy.buckley@cern.ch>

	* Provide more options to specify the Cython command to be
	used. Thanks to Christian Holm Christensen.

2021-07-22  Andy Buckley  <andy.buckley@cern.ch>

	* Fix yAvgErr -> yErrAvg typo in Scatter2D.yErrAvgs.

2021-07-20  Dmitri Kalinkin  <dmitry.kalinkin@gmail.com>

	* yodascale: improved handling of .yoda.gz extensions, and adding --output.

	* Fix a bug with reading files while running with non-US locales.

2021-06-28 Christian Gutschow <chris.g@cern.ch>

	* Remove rogue s.variations() call, causing rivet-merge to crash

2021-06-07  Andy Buckley  <andy.buckley@cern.ch>

	* Change the Axis2D edge-uniqueness test to be based on the
	smallest bin width rather than the median. (Smarter could be to
	comparer with the smallest of the surrounding bin widths. Or drop
	entirely, as 1D doesn't *seem* to have real problems with
	numerical near-matches.)

2021-06-06 Christian Gutschow <chris.g@cern.ch>

	* Remove adoptPoint, make addPoint(Point) argument non-const
	since one should always want to update the parent of the point.

2021-04-28 Louie Corpe  <lcorpe@cern.ch>

	* Add updateTotalUncertainty method which allows the user to
	automatically set the total error to the sum in quad of the error
	components for each point.

	* Add adoptPoint(s) methods to the Scatter*D classes, which allows
	to add a previously-instantiated point while modifying its
	parentage so that it points back to that Scatter. This is then
	substituted into the python binding for addPoint so that the user
	does not need to manually set the parentage of a point.

	* Modify the Scatter*D copy constructor so that the parentage of
	the relevant points is correctly set, to avoid set faults after a
	Scatter*D is clone()'d.

	* Add some missing functionality which used to only be available
	to Scatter2D to also cover Scatter{1,3}D.

	* Add many additional tests to cover the ErrorBreakdown
	functionality in existing pytest scripts

2021-04-22  Dmitri Kalinkin  <dmitry.kalinkin@gmail.com>

	* Bin2D: use fuzzyEquals for bin edge comparisons. Required for
	correct rivet-merge behaviour with 2D histograms.

2021-04-09  Andy Buckley  <andy.buckley@cern.ch>

	* Provide x,yWidths() functions on Histos and Profiles.

2021-03-31  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.9.0 release.

	* Add missing inline declarations to free IO functions.

	* Add fillDim() methods to the Bin, Bin1D and Bin2D classes.

	* Rename the Point getParentAO etc. to getParent, using the new
	Scatter base, and improve the accessor methods.

	* Add Scatter base class to the Scatter classes, with rmPoints()
	implemented there.

	* Add Binned and Fillable base classes, the former introducing the
	fillDim() method and rmBin(), and use them as ABCs for the
	counter, histo and profile types.

2021-03-30  Andy Buckley  <andy.buckley@cern.ch>

	* Allow YODA's Python interface to read from StringIO and FileIO objects.

	* Add rmPoint() and rmPoints() methods on all Scatter types.

2020-03-30  Christian Gutschow  <chris.g@cern.ch>

	* Change scaleDim() to scale() for points and scatters

2021-03-29  Andy Buckley  <andy.buckley@cern.ch>

	* Remove ROOT5 compatibility, and handle 6.22 change in PyROOT.

2021-03-26  Christian Holm Christensen  <cholm@cern.ch>

	* Fix out-of-source builds re. bash completions.

	* Fixes to the Profile1D Python interface.

2021-03-26  Andy Buckley  <andy.buckley@cern.ch>

	* Add <limits> header include to AnalysisObject.h to support GCC11
	(cf. http://gcc.gnu.org/gcc-11/porting_to.html)

2020-12-10  Andy Buckley  <andy.buckley@cern.ch>

	* Restructure yodamerge to use pairwise merges, avoiding
	simultaneous loading of all the input files and greatly speeding
	up processing. Simultaneous simplification by replacement of
	yodamerge stacking functionality with yodastack.

2020-11-25  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.8.5

2020-11-24  Andy Buckley  <andy.buckley@cern.ch>

	* Add relErrs() functions to the H1D and H2D Python interfaces.

	* Add an explicit configure test and override variable for the cython executable.

2020-11-16  Andy Buckley  <andy.buckley@cern.ch>

	* Fix typo from xAvgErr -> xErrAvg in Scatter2D.xErrAvgs() Python function.

2020-11-05  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.8.4

2020-11-03  Christian Gutschow  <chris.g@cern.ch>

	* Don't suppress cross-section-normalised empty histograms in yodamerge

2020-11-03  Andy Buckley  <andy.buckley@cern.ch>

	* Use ROOT's ROOT_VERSION_CODE and ROOT_VERSION macros to handle
	the changing TPython API.

	* Do not apply bin-width scaling by default between YODA and ROOT
	binned objects.

	* Improve ROOT conversion utilities to support a fuller set of
	width-scaling and focus-mapping options.

	* Fix Point1D.setXErrs() function to handle sources and asymm
	errors correctly.

	* Map scatter reset() functions into Python.

2020-08-31  Andy Buckley  <andy.buckley@cern.ch>

	* Create bash completion dir in $prefix/etc if it doesn't exist.
>>>>>>> release-1-8

2020-07-15  Andy Buckley  <andy.buckley@cern.ch>

	* Fix missing call-parentheses in Python-mapped Bin classes,
	including in the __repr__ functions, which was making print(bin)
	crash.

2020-07-02  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.8.3

2020-06-24  Dmitry Kalinkin <dmitry.kalinkin@gmail.com>

	* The python method `Histo2D.addBins` was reimplemented using
	`Histo2D::addBins()` C++ method instead of `Histo2D::addBin()` for
	better performance.

2020-06-24  Andy Buckley  <andy.buckley@cern.ch>

	* Make the low stats error for variances strictly require Neff >
	1, rather than a fuzzy comparison that can cause trouble
	downstream.

2020-06-22  Andy Buckley  <andy.buckley@cern.ch>

	* Make xyMids,Foci,Errs,Mins,Maxs etc. runtime configurable with
	'unique' and 'asgrid' optional params.

	* Convert geometric axis-property array functions on Histo2D and
	Profile2D to return the unique edges, mins, maxes, mids,
	etc. rather than the heavily repeated versions for all the bins.

2020-06-06  Andy Buckley  <andy.buckley@cern.ch>

	* Fix Histo2D.volumes() Python mapping, and add sumWs() functions to all histo types.

	* Add asgrid optional arguments to value-related Python methods for Histo2D and Profile2D

	* Add computation of Python versions and passing them to Cython as command-line flags.

2020-05-08  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.8.2.

2020-04-28  Andy Buckley  <andy.buckley@cern.ch>

	* Fix off-by-one error in Axis2D.numBinsX/Y() return values, fixing Histo2D and Profile2D.

	* Add numBinsX() methods to the 1D histogram and profile classes.

2020-04-26  Christian Gutschow <chris.g@cern.ch>

	* Py3 compatibility fix

2020-04-23  Valentin Boettcher <hiro@protagon.space>

	* Fix call to `Histo1D.annotationsDict`

2020-04-03  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.8.1

2020-02-26  Jon Butterworth <J.Butterworth@ucl.ac.uk>

	* Fix list-return read YODA-format function.

2020-02-21  Alison Clarke <alison.r.clarke@durham.ac.uk>

	* Removed unwanted space at end of headers.

	* Set correct dimension when calling setErrs.

	* Added zerrs to 3DScatter headers.

2020-02-20  Alison Clarke <alison.r.clarke@durham.ac.uk>

	* Added xErrs, yErrs, zErrs to Scatter3D.pyx

2020-02-10  Andy Buckley  <andy.buckley@cern.ch>

	* Add underflow and overflow reporting to the verbose yodals printout.

2020-02-08  Louie Corpe <louie.dartmoor.corpe@cern.ch>

	* Re-instate title() and fix bug in z-error storage for scatter 3Ds.

2020-02-07  Christian Gutschow <chris.g@cern.ch>

	* Python3 compatibility tweaks

2020-02-03  Andy Buckley  <andy.buckley@cern.ch>

	* Add a pdfspace() function in C++ and a Python equivalent
	-- recoded rather than mapped, due to the technical implications of
	passing Python callables as std::functions -- for custom binning
	from a density function.

2020-01-24  Andy Buckley  <andy.buckley@cern.ch>

	* Fix YODA 1.7 style call to AO.dim.

2020-01-22  Louie Corpe <louie.dartmoor.corpe@cern.ch>

	* Update yodamerge ao_out.point(i).setVal(dim, val_i)

2020-01-14  Dmitry Kalinkin <dmitry.kalinkin@gmail.com>

	* IO.pyx: missing python3 compatibility

2020-01-14  Andy Buckley  <andy.buckley@cern.ch>

	* Sort dicts on IO write(), and return ordered dicts in read mode if possible.

2019-12-20  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.8.0.

2019-11-01  Andy Buckley  <andy.buckley@cern.ch>

	* Add extra optional bool arguments to the mkScatter converter
	functions for Histo1D and Histo2D types.

	* Force rebuild of the Python interface if a sufficient Cython is
	found, even if the generated .cpp file is present at
	configure-time.

2019-09-05  Andy Buckley  <andy.buckley@cern.ch>

	* Final conversion to use ast module not just in autotype but as
	first choice in AO.annotation.

2019-08-20  Andy Buckley  <andy.buckley@cern.ch>

	* Remove ALL uses of @property in the Python interfaces: all
	methods must have call-parentheses now.

2019-07-30  Andy Buckley  <andy.buckley@cern.ch>

	* Improve Python annotation parsing to preferentially use ast rather than yaml.

2019-06-21  Andy Buckley  <andy.buckley@cern.ch>

	* Add x/yErrs and x/yErrAvgs functions to Scatter2D Python.

2019-06-018  Louie Corpe <lcorpe@cern.ch>

	* Release 1.7.7

	* Fix printing of YAML annotations.

	* Fix Python 3 / Unicode compatibility for Point.pyx.

2019-06-07  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.7.6

2019-06-06  Andy Buckley  <andy.buckley@cern.ch>

	* Add xEdges and yEdges methods to the 2D Histo and Profile classes, in C++ and Python.

	* Remove @property attributes from Python xEdges methods. More of that to come in version 1.8.0.

2019-05-26  Andy Buckley  <andy.buckley@cern.ch>

	* Fix Python3/argparse attribute access bug in yodamerge.

2019-05-09  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.7.5

2019-05-06  Andy Buckley  <andy.buckley@cern.ch>

	* Convert bin/* scripts to use Python3-compatible argparse rather than old optparse.

2019-05-02 Christian Gutschow <chris.g@cern.ch>

	* Fix Histo1D::integralRange to include the second-argument bin content as described in the docstring.

2019-04-29  Andy Buckley  <andy.buckley@cern.ch>

	* Fix Python3 StringIO import compatibility -- thanks to Tom Neep for the patch!

2019-03-05  Andy Buckley  <andy.buckley@cern.ch>

	* Add -m/-M filtering to yodadiff.

2019-02-27  Andy Buckley  <andy.buckley@cern.ch>

	* Fix HistoBin2D printing in Python interface.

2019-02-17  Jon Butterworth  <j.butterworth@ucl.ac.uk>

	* Protect yodamerge against zero-valued (?!) ScaledBy attributes.

2018-12-10  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.7.4

2018-11-16 Christian Gutschow <chris.g@cern.ch>

	* Roll out sameBinning methods for Profile1D and Profile2D.

2018-11-08 Christian Gutschow <chris.g@cern.ch>

	* Add sameBinning methods for Histo1D and Histo2D.

2018-11-08  Andy Buckley  <andy.buckley@cern.ch>

	* Remove debug couts from single-AO Writer::write() function.

	* Add --ignore-missing and --ignore-new flags to yodadiff.

	* Tidy up point-comparison output of yodadiff.

2018-10-13 Christian Gutschow <chris.g@cern.ch>

	* Fix additional weighting in yodamerge

2018-09-24  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.7.3

2018-09-12 Louie Corpe  <lcorpe@cern.ch>

	* Fix bug in multi-err point reader which was not parsing Variations correctly,
	and a minor typo where the err- was duplicated for the additional columns.

2018-09-06  Andy Buckley  <andy.buckley@cern.ch>

	* Fix missing y and z components of Point2D and Point3D equality testing.

2018-09-04  Andy Buckley  <andy.buckley@cern.ch>

	* Add array accessors of x,y,zMins/Mids/Maxs/Vals/Errs, etc. to
	Python Histo2D and Profile2D.

2018-08-30  Andy Buckley  <andy.buckley@cern.ch>

	* Update embedded yaml-cpp to v0.6.0.

	* Convert xyzMin/Max properties to functions in the Python interfaces.

	* Return numpy arrays if possible in Python interface array methods.

2018-08-23  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.7.2

	* Add missing bin(i) method to Python Profile1D interface.

2018-08-22  Andy Buckley  <andy.buckley@cern.ch>

	* Avoid const-overloading clash for binAt functions.

2018-08-14  Chris Gutschow  <chris.g@cern.ch>

	* Merge Graeme Watt's modifications to yodadiff.

2018-08-14  Andy Buckley  <andy.buckley@cern.ch>

	* Release 1.7.1

2018-08-08  Andy Buckley  <andy.buckley@cern.ch>

	* yodadiff now supports quiet (-q) and list (-l) modes.

2018-06-01  Louie Corpe  <lcorpe@cern.ch>

	* Point1,2,3D now support multiple error sources for the highest dimension.

	* Scatter1,2,3D now read in/out with additional columns for the extra error
	sources, with a variations() method to check with sources are available

2018-05-02  Andy Buckley  <andy.buckley@cern.ch>

	* StringUtils.h: Replace std::ptr_fun (removed in C++17) with a lambda function. Thanks to Stefan Richter.

2018-04-30  Andy Buckley  <andy.buckley@cern.ch>

	* Add "-" = stdin/stdout recognition to C++ IO functions.

	* Convert remaining Python read/write methods to use the C++ IO functions.

	* Convert Python read/write methods with filename arguments to use the gzip-aware IO functions.

2018-04-27  Andy Buckley  <andy.buckley@cern.ch>

	* Fix missing lock=false flag initialisation in Histo2D constructor from a Bins vector.

	* Improve axis locking error messages.

2017-12-21  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.7.0 release

2017-12-11  Andy Buckley  <andy.buckley@cern.ch>

	* Add Nentries printout to yodals -v

2017-09-18  Andy Buckley  <andy.buckley@cern.ch>

	* Patches for ROOT conversion from Robert Hatcher -- thanks!

2017-09-16  Andy Buckley  <andy.buckley@cern.ch>

	* Add YODA format version annotation, at version 2, and update
	YODA reader to use version info and multiline YAML EOF marker.

	* Write YODA annotations in YAML with a --- YAML break-line.

2017-09-14  Andy Buckley  <andy.buckley@cern.ch>

	* Enable compressed writing from Python.

2017-09-13  Andy Buckley  <andy.buckley@cern.ch>

	* Remove UNUSED macro in favour of anonymous args.

	* Enable zipped writing... but only works from C++ so far.

2017-09-11  Andy Buckley  <andy.buckley@cern.ch>

	* Add HistoBin2D::area(), and provide a default normto=1.0
	argument on the Python Histo2D.normalize() method.

2017-09-04  Andy Buckley  <andy.buckley@cern.ch>

	* Change license explicitly to GPLv3, cf. MCnet3 agreement.

	* Parse YODA format AO headers as YAML (restriction to single-line dict entries for now).

2017-08-24  Andy Buckley  <andy.buckley@cern.ch>

	* Use a slightly enhanced fast numeric parser in ReaderYODA (taken
	from LHAPDF, originally inspired by Gavin Salam).

	* Add an UNSCALE spec option to yodascale, to undo ScaledBy effects.

2017-08-19  Andy Buckley  <andy.buckley@cern.ch>

	* Add optional zlib support via zstr -- massive thanks to Dmitry
	Kalinkin for the lovely patch!

2017-08-16  Andy Buckley  <andy.buckley@cern.ch>

	* Fix setVal(i, x) numbered-axis methods on Point2D and Point3D:
	switch break statements were missing.

	* Explicitly load all ROOT objects as a list rather than
	generator. Patch from Dmitry Kalinkin.

2017-07-24  Andy Buckley  <andy.buckley@cern.ch>

	* Improvements to yodaplot, including two operating modes: the
	default CMP mode is suitable for plotting histos by path, from raw
	.yoda files.

	* Update yoda.plotting functions to treat plot-keys as args and AO
	annotations via case-insensitive keys.

	* Add annotationsDict to the Python AO interface.

	* Add AO as an alias for AnalysisObject.

2017-07-23  Andy Buckley  <andy.buckley@cern.ch>

	* Add parallel/compatibility yoda1 package to aid eventual transition to YODA v2.

2017-07-22  Andy Buckley  <andy.buckley@cern.ch>

	* Add x,y,zMins and Maxs to all 1D data types and scatters (and
	x,yMin/Max to the scatters) -- Python interface only.

	* Rework some of the yoda.plotting tools, making it a bit more
	compatible with user-scripted matplotlib.

2017-07-18  Andy Buckley  <andy.buckley@cern.ch>

	* Add convenience aliases H1D, H2D, P1D, P2D, and S1D, S2D, S3D
	for the HistoXD, ProfileXD, and ScatterXD classes respectively.

2017-07-08  Andy Buckley  <andy.buckley@cern.ch>

	* Add xyVals/Errs and other 'bin array property' accessors to the
	Python Histo1D and Profile1D types: important for connection to
	matplotlib.

2017-06-28  Andy Buckley  <andy.buckley@cern.ch>

	* Use Python natsort library to sort yodals output if available.

2017-06-18  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.6.7 release.

2017-05-12  Andy Buckley  <andy.buckley@cern.ch>

	* pyext/yoda/rootcompat.pyx: Fix ordering of TH1 vs. TProfile
	conversion -- TProfile *is* a TH1, so we have to test for the more
	specific type-match first. Thanks to Dmitry Kalinkin for the
	patch.

2017-05-02  Andy Buckley  <andy.buckley@cern.ch>

	* Add static Reader methods to match the Writer ones.

2017-02-23  Andy Buckley  <andy.buckley@cern.ch>

	* Fix Histo2D and Profile2D total distribution reading from YODA format.

2017-02-19  Holger Schulz <holger.schulz@durham.ac.uk>

	* Convert TH1F to TH1D in root2flat. Much simpler than duplicating
        the TH1D stuff in pyext.

2016-12-13  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.6.6 release.

2016-12-12  Holger Schulz <holger.schulz@durham.ac.uk>

	* Bugfixes in Cython bins accessors for Histo2D.

2016-11-17  Leif Lonnblad <leif.lonnblad@thep.lu.se>

	* Fixed warning messages about the obsoleteness of AIDA so that the scripts actually still work.

2016-09-28  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.6.5 release, for the benefit of ROOT fans.

	* Fix handling of --enable/disable-root configure options.

2016-09-26  David Grellscheid  <david.grellscheid@durham.ac.uk>

	* Improvements to Cython version testing.

2016-09-25  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.6.4 release.

2016-09-20  David Grellscheid  <david.grellscheid@durham.ac.uk>

	* Remove aliases for @property functions. They were scheduled for
	removal anyway, and don't work with Cython >= 24.

2016-09-06  Andy Buckley  <andy.buckley@cern.ch>

	* Update configure scripts to use newer (Py3-safe) Python testing
	macros.

2016-08-09  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.6.3 release!

2016-07-22  Andy Buckley  <andy.buckley@cern.ch>

	* Add 'add' modes for scatter combination to yodamerge.

	* Fix yodamerge scatter averaging to use the first AO.

2016-07-21  Andy Buckley  <andy.buckley@cern.ch>

	* Add --type-mismatch-mode flag and fallback logic to yodamerge.

	* Fix yodamerge logic to handle cases where an AO only appears once.

2016-07-19  Andy Buckley  <andy.buckley@cern.ch>

	* Deprecate flat2yoda script and add warning output to it and the AIDA conversion scripts.

	* Add a convenience yoda2yoda script.

2016-07-14  Andy Buckley  <andy.buckley@cern.ch>

	* Try to build PyROOT interface by default, if root-config is found.

2016-07-11  Andy Buckley  <andy.buckley@cern.ch>

	* Remove accidentally remaining reference to Boost flags in yoda-config.

2016-07-06  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.6.2 release!

2016-07-05  Andy Buckley  <andy.buckley@cern.ch>

	* Pass the toNewScatter3D() scalebyarea flag to the called toScatter3D() functions.

2016-06-06  Andy Buckley  <andy.buckley@cern.ch>

	* Re-enable the disabled-for-some-reason Scatter1D combineWith Python mappings.

2016-04-28  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.6.1 release!

	* Add a unit test for annotation handling correctness.

	* Fix numerical precision of string storage of floating-point attributes.

	* Fix a bug in use of the replacement for lexical_cast.

2016-04-20  Andy Buckley  <andy.buckley@cern.ch>


	* Version 1.6.0 release!

2016-04-16  Andy Buckley  <andy.buckley@cern.ch>

	* Extend SFINAE craziness to allow writing of any object
	(e.g. smart pointer) that can be dereferenced to something that
	has AnalysisObject as its base class... and also to any container
	of them! Amazing what you can do with C++11!

2016-04-14  Andy Buckley  <andy.buckley@cern.ch>

	* Add a few consts to the arguments in Scatter error setting via pairs.

	* Fix double-writing of minus errors in WriterYODA for Scatter1D
	and Scatter3D. Thanks to Graeme Watt for the report and fix.

2016-04-12  Andy Buckley  <andy.buckley@cern.ch>

	* Remove Boost dependency and require C++11 compilation.

2016-04-08  Andy Buckley  <andy.buckley@cern.ch>

	* Add a --guess-prefix flag to yoda-config, cf. fastjet-config.

2015-12-20  Andy Buckley  <andy.buckley@cern.ch>

	* Change AO uncomputable division and mkScatter operations to
	return/set NaN rather than 0 -- behaviour change requires new
	major version series 1.6.

2016-03-09  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.9! (oh no, we're out of convenient version number space!!)

2016-03-08  Andy Buckley  <andy.buckley@cern.ch>

	* Add abs function to eq calculation in yodadiff.

2016-02-29  Andy Buckley  <andy.buckley@cern.ch>

	* Remove blocking of builds against ROOT6 -- it works fine.

2016-02-16  Andy Buckley  <andy.buckley@cern.ch>

	* Add a --add option to yodamerge, for simple histo
	stacking. Thanks to Chris Gutschow for the patch, although my
	spidey sense is tingling...

2015-12-21  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.8!

	* Add a rebinning unit test, pytest-rebin.

	* Add optional range arguments to rebinBy methods, allowing block
	rebinnings to be applied only within a range of (original) bin
	indices.

	* Add missing root.py submodule file. Oops!

2015-12-20  Andy Buckley  <andy.buckley@cern.ch>

	* Convert linspace to use multiplication rather than repeated
	addition to construct edge values, reducing precision errors.
	Thanks to Holger Schulz for the suggestion.

2015-12-15  Andy Buckley  <andy.buckley@cern.ch>

	* Add xEdges() methods to Axis1D and the Histo1D and Profile1D
	that use it. The returned edge lists are finite only, i.e. they do
	not contain the +-inf values on the ends of the internal
	BinSearcher edges.

2015-12-13  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.7!

	* Extend batch-adding in ReaderYODA to include Scatter types.

	* Add a match_aos function to Python, for filtering AO lists/dicts
	on path patterns and anti-patterns.

2015-12-12  Andy Buckley  <andy.buckley@cern.ch>

	* Add a flag to yoda2root to change whether the conversion is to
	'proper' types or to (more robustly) TGraphAsymmErrors objects.

	* Fix accidental use of S2D_MODE flag where S1D_MODE should have
	been used, in yodamerge. Thanks again to Radek Podskubka.

	* Allow new rebinTo() merging to restrict to a subset of the bin
	range, merging the outside bins into the overflow distributions.

2015-12-11  Andy Buckley  <andy.buckley@cern.ch>

	* Add a rebinTo() method on Axis1D, allowing rebinning to a new
	given set of bin edges. Add an explicitly named rebinBy(), and
	overloaded rebin() aliases for both, and pass through to Histo1D
	and Profile1D APIs. Plus other internal tweaks to binning
	functionality... anticipating/fuelling the fundamental rewrite.

2015-12-10  Andy Buckley  <andy.buckley@cern.ch>

	* Improve ReaderYODA to use temporary bin containers, to minimise
	calling sort when adding bins to histos. A quick test suggests
	this has sped up big file reading by a factor of 30 or so!!!

	* Add missing addBins() operators (only in C++ so far) to Histo
	and Profile classes.

	* Fix Counter::numEntries to return an unsigned long rather than double.
	Thanks to Radek Podskubka for the bug discovery and detective work.

	* Improve sortedvector to insert new elements into the sorted
	position, rather than resorting the whole vector. This should be a
	bit more efficient, but I think the asymptotic complexity is the
	same. Might help a bit with reading big data files.

2015-12-04  Andy Buckley  <andy.buckley@cern.ch>

	* Add yoda.HAS_ROOT_SUPPORT flag, for API user convenience.

2015-11-22  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.6!

	* Make AO path setting and retrieval prepend a leading slash if it
	is missing (unless the path is completely empty).

2015-11-21  Andy Buckley  <andy.buckley@cern.ch>

	* Add root2yoda conversion script.

	* Deprecating yoda.to_root() in favour of yoda.root module, which
	contains to_root and to_yoda functions, as well as a ROOT file
	walking function.

2015-11-17  Andy Buckley  <andy.buckley@cern.ch>

	* Map ROOT-to-YODA (as scatter) functions to Python. Phew.

	* Map new to-ROOT functions, including TGraph ones, to Python.

2015-11-16  Andy Buckley  <andy.buckley@cern.ch>

	* ROOTCnv.h: Add toScatter3D ROOT->YODA, and toNew* YODA->ROOT
	conversion routines.

	* ROOTCnv.h: Fix bug in toTH2D(const Histo2D& h) as used with
	ROOT6. Thanks to Tim Martin.

2015-11-05  Andy Buckley  <andy.buckley@cern.ch>

	* Fix double-dealloc in new Point class hierarchy Python mapping.

2015-10-23  Andy Buckley  <andy.buckley@cern.ch>

	* Make the version() function inline, and the numerical constants static.

	* Change the default plotting backend to MPL rather than the much slower PGF.

2015-10-09  Andy Buckley  <andy.buckley@cern.ch>

	* Reinstate __getitem__  special methods for Scatters in Python.

	* Provide dim() methods/attributes for the Point and Bin base classes.

	* Rename set*Err to set*Errs for the asymmetric variants. Plural
	aliases are also provided for the symm case.

2015-10-08  Andy Buckley  <andy.buckley@cern.ch>

	* Pass std::pairs by reference in Point*D error setting functions.

	* Add Point base class with generic accessors to Point*D
	properties via an integer axis ID argument.

2015-10-07  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.5 release.

	* Counter.pyx: Typo fix in sumW mapping.

	* yodamerge: Re-add checking for non-emptiness before merging, in
	case the empty ones are missing a ScaledBy attribute. Won't
	normally apply to Profiles, since they don't usually get
	normalised, but we might as well include them in the vetoing since
	empty histos don't contribute to the merging. Added a command-line
	option to disable this heuristic since in very strange situations
	a null sumW does not mean no fills.

2015-10-06  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.4 release.

	* ReaderYODA: Typo fixes in Counter filling of sumW and Scatter3D reader state flag.

	* yodamerge: add merging heuristics for Scatter1D and Scatter3D (needs unification)

2015-10-05  Andy Buckley  <andy.buckley@cern.ch>

	* yodamerge: add a fix for empty-in-all-runs histo merging; thanks
	to Daniel Rauch.

2015-10-04  Andy Buckley  <andy.buckley@cern.ch>

	* Adding dim() function and corresponding Python attribute to AnalysisObject.

	* Map Counter arithmetic operations into Python.

	* Map Counter mkScatter() into Python (as bound method).

	* Add a YODA::version() function, mapped into Python and used to
	set the yoda.__version__ variable.

2015-10-01  Andy Buckley  <andy.buckley@cern.ch>

	* Expose the yoda.plot() Python function in a way that doesn't
	automatically induce a dependence on matplotlib.

2015-09-30  Andy Buckley  <andy.buckley@cern.ch>

	* Fix yodals to work with Counters.

2015-09-23  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.3 release.

	* Update Boost version requirement to 1.48, due to use of
	type_traits/has_dereference, and add a check for that feature's
	header.

2015-09-19  Andy Buckley  <andy.buckley@cern.ch>

	* Further improvements to handling leading _multiple_ # marks on
	YODA format BEGIN lines.

2015-09-11  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.2 release.

	* Tolerate leading # symbols without separating whitespace on
	BEGIN lines in YODA format parsing.

	* Further improvements to handling LowStatsErrors in YODA format writing.

	* Fix shadowed variables that made ReaderYODA unhappy.

2015-09-03  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.1 release.

	* Fix bugs in Python wrapper for Point3D.

2015-08-28  Peter Richardson  <Peter.Richardson@durham.ac.uk>

	* Catch LowStatsError when writing multiple histograms so only the
	histogram with the problem is not written

2015-08-28  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.5.0 release.

2015-08-24  Andy Buckley  <andy.buckley@cern.ch>

	* Improve protection of efficiency calculation against the weird
	world of general weighted events.

2015-08-17  Andy Buckley  <andy.buckley@cern.ch>

	* Add some protection against calling matplotlib's legend() method
	if there are no valid labels to display, to suppress an MPL
	warning message when using yoda.plot().

2015-08-12  Andy Buckley  <andy.buckley@cern.ch>

	* Fix cut & paste typo, and add LowStatsError catching in Profile division.

2015-08-11  Andy Buckley  <andy.buckley@cern.ch>

	* Replace old Spirit-based ReaderYODA with the new hand-rolled one.

	* Adding filling of Histo1D, Profile1D, Histo2D and Profile2D in
	new ReaderYODA. More hacking of Axis and Histo/Profile
	interfaces... needs clean-up, and infinite binning implementation.

2015-08-07  Andy Buckley  <andy.buckley@cern.ch>

	* Convert the ReaderFLAT parser to also use a simple hand-written parser rather than Spirit.

2015-08-04  Andy Buckley  <andy.buckley@cern.ch>

	* Add methods for Counter, Axis and Histo1D internal state
	access/setting, mainly for new persistency. NEEDS PRE-RELEASE TESTING!!!

2015-07-30  Andy Buckley  <andy.buckley@cern.ch>

	* Remove # markers from YODA format BEGIN/END output. The parser
	will continue to accept them.

2015-07-29  Andy Buckley  <andy.buckley@cern.ch>

	* Add SFINAE trait magic to restrict write(RANGE) functions to
	accepting iterables. Also generalising to allow either
	container-of-objects or container-of-pointers args by providing a
	writeBody(AO*) function to complement writeBody(AO&). Based on a
	patch from Lukas Heinrich.

	* Add configuration of output streams to throw exceptions on
	bad/fail state (based on patch from Lukas Heinrich).

2015-07-01  Andy Buckley  <andy.buckley@cern.ch>

	* 1.4.0 release.

2015-06-30  Andy Buckley  <andy.buckley@cern.ch>

	* More tweaks to yodamerge: adding control of S2D merging
	strategy, and now performing weighted normalized histo merges
	without reference to an absolute normalization.

	* Change yodamerge norm-detection heuristic to just look for a
	ScaledBy attribute rather than fuzzily compare norms.

2015-06-26  Andy Buckley  <andy.buckley@cern.ch>

	* Removing add, subtract, and divide functions and operators on
	Scatter types, and re-implementing Histo and Profile divide
	functions explicitly rather than via mkScatter. Also removed from
	the Python interface. The combine() methods remain.

2015-06-24  Andy Buckley  <andy.buckley@cern.ch>

	* Adding workaround versions of binAt to all the Python histo
	types (for some reason the direct mapping that works for bin(i)
	produces a compile error for binAt(x) :-/

2015-06-23  Andy Buckley  <andy.buckley@cern.ch>

	* Renaming, tidying, completing, etc. the Python-mapped methods on Bin1D and Bin2D.

	* Rename Python Histo2D mean, variance, etc. pair-returning
	methods to xyMean, xyVariance, etc., to distinguish from Profile2D
	mean, variance, etc.

	* Add Python mappings of all the methods below.

	* Add full set of {x,y}{Mean,Variance,StdDev,StdErr,RMS} to 1D and
	2D binned distributions.

	* Add optional includeoverflows=True argument to all binned AO
	numEntries and effNumEntries.

	* Fix type of numEntries to always be unsigned long.

2015-06-18  Andy Buckley  <andy.buckley@cern.ch>

	* Fix typos in Point3D Python mapping (accidentally trying to get
	the ptr via _Point2D rather than _Point3D).

2015-06-13  Andy Buckley  <andy.buckley@cern.ch>

	* Adding an AnalysisObject::name() method, to return the last part
	of the path. Mapped into a Python property.

	* Adding an optional usestddev argument to mkScatter for profile
	types, so the error bars can represent distribution width rather
	than uncertainty on the mean. Mapped to Python.

2015-06-08  Andy Buckley  <andy.buckley@cern.ch>

	* Adding unpatterns arguments to Python read functions, and
	auto-conversion from single strings and re.compile()d strs.

2015-06-04  Andy Buckley  <andy.buckley@cern.ch>

	* Add binAt(x,y) and binIndexAt(iglobal) Python methods for 2D
	histos. Still want a way to get and pass a pair of bin indices, I
	think.

	* Adding includeoverflows optional args for Histo1D (eff)numEntries.

	* Adding Rename Histo1D integral() methods as integral(),
	integralRange(), and integralTo(), and mapping to Python.

2015-06-02  Andy Buckley  <andy.buckley@cern.ch>

	* Adding missing binAt and binIndexAt methods to Histo1D and
	Profile1D, plus other minor Python mapping tweaks.

	* Add a regex pattern match optional argument to the IO.read()
	Python functions, for pre-emptive filtering.

2015-03-27  Andy Buckley  <andy.buckley@cern.ch>

	* Fix a harmless possibility to raise an FPE exception in the
	BinSearcher. Thanks to Leif Lonnblad for the discovery, debug and
	patch!

2015-03-19  Andy Buckley  <andy.buckley@cern.ch>

	* Bump version for 1.3.1 release.

2015-03-06  Andy Buckley  <andy.buckley@cern.ch>

	* Adding usefocus optional argument to some mkScatter functions, plus the Python bindings.

	* Cleaning up some Python mappings of 2D histogram bin classes.

	* Removing mappings of bin-level fill and scale operations in Python.

	* Fix formatting and error handling in Python Bin and Dbn __repr__ methods.

	* Add a -i/--in-place option pair on yodascale.

2015-02-05  Andy Buckley  <andy.buckley@cern.ch>

	* Convert script matching options to use re search rather than match.

	* Adding matching options and verbose option to yodals.

2015-01-27  Andy Buckley  <andy.buckley@cern.ch>

	* Improvements and additions to ROOTCnv.h routines, particularly
	to TProfile creation: thanks to Roman Lysak for advice.

2015-01-16  Andy Buckley  <andy.buckley@cern.ch>

	* Add convenience YODA/YODA.h header.

2015-01-15  Andy Buckley  <andy.buckley@cern.ch>

	* yodascale now uses PointMatcher and can normalize or multiply to
	abs values or ref histos/bin ranges.

2015-01-05  Andy Buckley  <andy.buckley@cern.ch>

	* Adding yoda.matcher Python sub-package with PointMatcher
	functionality. To be used in Professor 2.0 and in yodascale.

	* Adding 'scat2' type to yodahist.

	* Add match/unmatch args to all conversion scripts, via a new Python yoda.script_helpers function.

	* Script updates, improved docstrings, and improved tab completion.

2014-12-10  Andy Buckley  <andy.buckley@cern.ch>

	* Add a yoda.plotting sub-module, based on matplotlib.

2014-12-03  Andy Buckley  <andy.buckley@cern.ch>

	* Small build improvements: cleaning test1.root from the yoda2root
	test, and adding a make target & flag file for mktemplates in
	pyext/yoda to make sure that it only gets run once.

2014-11-25  Andy Buckley  <andy.buckley@cern.ch>

	* Handle overflow filling in binned types without invoking an exception.

	* Change inRange to have non-fuzzy comparison behaviour.

2014-11-11  Andy Buckley  <andy.buckley@cern.ch>

	* Improving/adding __div__ functions in Python for all binned types.

	* Add std:: prefix to isinf() calls in BinSearcher.h.
2014-09-30  Andy Buckley  <andy.buckley@cern.ch>

	* 1.3.0 release!

	* Use numEntries() rather than effNumEntries() when checking
	consistency of inputs to efficiency() calculations -- the
	effNumEntries of a set can be smaller than that of a strict
	subset, surprisingly!

2014-09-17  Andy Buckley  <andy.buckley@cern.ch>

	* Small improvements to yodahist and yodaplot behaviours/UIs.

	* Adding setX/Y/Z(val, err) methods to Point3D.

	* Add an efficiency method for 2D histos.

	* Hide fill and fillBin methods from Python mappings of bin types.

2014-09-01  Andy Buckley  <andy.buckley@cern.ch>

	* YODA 1.2.1 release!

2014-08-29  Andy Buckley  <andy.buckley@cern.ch>

	* Hide non-const access to bin objects from histogram users:
	avoids potential for inconsistency between total dbns and in-range
	bins.

	* Bug in BinSearcher fixed by Peter Richardson: constructor
	arguments were passed in the wrong order when constructing a
	LinEstimator in cases where log binning wouldn't be allowed.

2014-08-26  Andy Buckley  <andy.buckley@cern.ch>

	* Add protection against / characters in histo names in yoda2root
	(thanks to Will Bell for the report and suggested patch).

2014-08-17  Andy Buckley  <andy.buckley@cern.ch>

	* Add +=, -=, *-, /=, ++ and -- operators to Counter, along with
	an (implicit) constructor from a double -- all for user
	convenience so Counter can be used in lieu of a simple number.

2014-08-15  Andy Buckley  <andy.buckley@cern.ch>

	* YODA 1.2.0 release!

	* Permit +-inf values to be filled into histograms; NaN fills will
	still explicitly throw an exception.

	* Add unit tests for Counter, Scatter1D, and Scatter2D, including
	persistency.

	* Adding YODA and FLAT format I/O for Scatter1D and Counter (as
	far as currently possible -- FLAT Counter can't be read due to a
	#item ambiguity, just like the one between the YODA format Point3D
	and ProfileBin1D). To be continued...

2014-08-14  Andy Buckley  <andy.buckley@cern.ch>

	* Python mappings for Dbn0D and Counter, and other improvements.

	* Adding val() and err() methods to Counter, and errW() and
	relErrW() to all DbnXD types.

	* Adding Scatter1D and Point1D types, with conversion from Counter
	supported. Both Counter and Scatter1D still need to be supported
	by YODA persistency.

2014-08-11  Andy Buckley  <andy.buckley@cern.ch>

	* Add ROOT version checking to configure. Thanks to Michael Grosse
	for the report/request.

2014-08-05  Andy Buckley  <andy.buckley@cern.ch>

	* Remove all methods not specific about the axis to which they
	refer, e.g. Histo1D::mean -> xMean. Also remove all related
	aliases (a nightmare to maintain) and low/highEdge and midpoint
	functions: use the proper xMin/Max/Mid from now on. This is a
	significant compatibility breaking API change (and the decision
	was not taken lightly) so will require a 2nd digit version change.

	* Lots of adding xMin/Max etc. functions to C++ and Python bin/histo classes.

	* Compiler pickiness fixes in BinSearcher.

	* Improvement to linspace, avoiding fuzzyEquals and again making
	sure that the end value is exact.

2014-07-23  Andy Buckley  <andy.buckley@cern.ch>

	* Fix to logspace: make sure that start and end values are exact,
	not the result of exp(log(x)).

	* Clean-up, minor improvements, and adding a test for BinSearcher and friends.

2014-07-19  Andy Buckley  <andy.buckley@cern.ch>

	* Various consistency improvements and minor bugfixes to Python
	mapping utils and Dbn and Bin objects.

	* Fix Axis2D::reset, which was resetting the total dbn and
	outflows, but not the bins!!! Thanks to Ewen Gillies for the
	report.

2014-07-18  Andy Buckley  <andy.buckley@cern.ch>

	* Add scaleX,Y,Z and scaleXYZ to Point and Scatter classes, and
	deprecate less explicit/consistent Scatter2D/3D.scale method.

2014-07-17  Andy Buckley  <andy.buckley@cern.ch>

	* yodascale now writes out rescaled histograms and profiles rather than scatters.

	* A few more improvements on Point2D/3D, adding x,y,zMin/Max function mappings.

	* Add first version of a yodascale script, based on code from Simone Amoroso.

2014-07-16  Andy Buckley  <andy.buckley@cern.ch>

	* More Scatter and 2D histo interface improvement.

	* Remove 'return *this' from Scatter2D/3D add and combine methods.

	* Add unit test checks for 1D and 2D mkScatter functions.

	* Improve Scatter2D/3D C++ and Python interfaces.

	* Add Scatter3D Python mapping.

2014-07-15  Andy Buckley  <andy.buckley@cern.ch>

	* Add auto-parsing of yes/no/on/off/true/false as bools in the
	Python ao.annotation() function.

	* Add parsing of yodaplot styles from command line args and
	analysis object annotations.

2014-07-12  Andy Buckley  <andy.buckley@cern.ch>

	* Fix infinite recursions in Python wrappers for Point2D and
	Point3D, and make the Python Point3D interface more standard.

	* Add yodaplot script for basic plotting, using pgfplots as a backend.

2014-07-10  Andy Buckley  <andy.buckley@cern.ch>

	* Add mkScatter(Scatter2D) and mkScatter(Scatter3D) functions and
	Python mappings: this allows all AOs to be used as args to
	mkScatter(...) without needing to check if they already are
	scatters.

2014-07-02  Andy Buckley  <andy.buckley@cern.ch>

	* Set y value and/or error to 0 in mkScatter(Histo1D) if an
	exception is thrown when calculating the appropriate values. Need
	an optional param to control this error handling behaviour between
	set-zero and skip-bin?

2014-07-01  Andy Buckley  <andy.buckley@cern.ch>

	* Add exception translation to the mkScatter functions.

	* Add -m/-M match/unmatch options to yodacnv -- useful for
	filtering histogram file contents in a YODA->YODA conversion.

2014-06-24  Andy Buckley  <andy.buckley@cern.ch>

	* Don't complain about merge assumptions if there is only one
	object with that path name to be 'merged'

2014-06-17  Andy Buckley  <andy.buckley@cern.ch>

	* Adding explicit int cast in Python wrapping of numEntries functions.

2014-06-13  Andy Buckley  <andy.buckley@cern.ch>

	* Adding yodals script to list data file contents.

2014-06-11  David Grellscheid  <David.Grellscheid@durham.ac.uk>

	* pyext/yoda/Makefile.am: 'make distcheck' and out-of-source
	builds should work now.

2014-06-10  Andy Buckley  <andy.buckley@cern.ch>

	* Fix use of the install command for bash completion installation on Macs.

2014-06-06  Andy Buckley  <andy.buckley@cern.ch>

	* YODA 1.1.0 release. Middle version number change to reflect API changes w.r.t 1.0.6.

	* Adding unit tests against ref data for yodamerge in make check.

2014-06-04  Andy Buckley  <andy.buckley@cern.ch>

	* Fix silly typos in yodamerge which somehow made it past "make check" testing :-(

2014-06-02  Andy Buckley  <andy.buckley@cern.ch>

	* YODA 1.0.7 release. DO NOT USE: prefer 1.1.0, above.

2014-05-30  Andy Buckley  <andy.buckley@cern.ch>

	* Removing 'foreach' macro definition and using raw BOOST_FOREACH instead until C++11 is allowed.

	* Adding pytest-p1d and pytest-p2d tests, and FLAT writing/reading in pytests.

	* Tweaking WriterFLAT and adding ReaderFLAT functionality for 2D histos and profiles.

2014-05-30  Holger Schulz  <hschulz@physik.hu-berlin.de>

        * Some basic (FLAT) write-out capability for 2D histos

2014-05-29  Andy Buckley  <andy.buckley@cern.ch>

	* Improvements to the yodahist script, including support for 2D
	histograms and input files.

	* Adding bin edges constructors for all 1D and 2D histos in Python.

2014-05-22  Andy Buckley  <andy.buckley@cern.ch>

	* Improvements to Profile2D and Point2D interfaces in Python.

	* Add a single-file at a time yodacnv multi-format converter
	script (thanks to Andrii Verbytskyi for the suggestion).

2014-05-19  Andy Buckley  <andy.buckley@cern.ch>

	* Typo fixes in Profile2D YODA-format parsing: 2D histo tests now pass!

	* Adding Python tests for Histo2D and Profile2D.

	* Adding a YODA/Predicates.h header and using it in Axis2D bin edge construction.

	* Enabling Profile2D writing in various Writers, and a bit of IO code tidying.

2014-05-17  Andy Buckley  <andy.buckley@cern.ch>

	* Disable writing out of Histo2D and Profile2D outflows for now,
	while they are redesigned, and get 2D I/O working for the in-range
	part.

2014-05-14  Andy Buckley  <andy.buckley@cern.ch>

	* Mapping the divide and efficiency functions into the Python
	interface as class methods, including the __div__ special
	function.

2014-05-13  Andy Buckley  <andy.buckley@cern.ch>

	* Add the AnalysisObject::type() method back in Python (even
	though type(ao) is more Pythonic, this may be useful)

2014-05-06  Andy Buckley  <andy.buckley@cern.ch>

	* Add Profile2D YODA format writing, note need for Scatter format
	change, add sumXY storage to both 2D histo types.

2014-05-03  Andy Buckley  <andy.buckley@cern.ch>

	* Adding YODA reader functionality for Histo2D and Profile2D, but
	without outflows support yet.

2014-04-25  Andy Buckley  <andy.buckley@cern.ch>

	* Adding simple command line yodahist script for quick 1D
	histogramming from plain text files, with weight support. More
	development to come!

	* Mapping linspace, logspace and a few stat functions into Python.

2014-04-24  Andy Buckley  <andy.buckley@cern.ch>

	* Fixes, script installation, and detailed numerical comparisons
	in yodadiff.

2014-04-17  Andy Buckley  <andy.buckley@cern.ch>

	* Change AnalysisObject::annotations to return the list of
	annotation keys rather than the map, since the previous behaviour
	mapped very badly into Python.

2014-04-16  Andy Buckley  <andy.buckley@cern.ch>

	* Add special case handling for 2-arg use of x2y scripts where the
	second arg is -, for stdin. This will be treated as writing out to
	stdout, not converting two files one of which is stdin.

2014-04-15  Andy Buckley  <andy.buckley@cern.ch>

	* Adding a more portable version of getline to be used in the YODA
	file parsing to avoid falling over on DOS-produced input files.

2014-04-14  Andy Buckley  <andy.buckley@cern.ch>

	* Adding the namespace protection workaround for Boost described
	at http://www.boost.org/doc/libs/1_55_0/doc/html/foreach.html

2014-04-13  Andy Buckley  <andy.buckley@cern.ch>

	* Adding an assumed-equal-run-size, ratio-like merging heuristic
	for Scatter2Ds to yodamerge, and renaming the --normalize-all flag
	to --assume-normalized.

	* Adding and installing a pkg-config data file for YODA.

	* Rationalising (and fixing?) the yodamerge logic re. user &
	normalization scalings, and making way for a Scatter2D merging
	heuristic.

2014-03-10  Andy Buckley  <andy.buckley@cern.ch>

	* YODA 1.0.6 release.

2014-03-06  Andy Buckley  <andy.buckley@cern.ch>

	* Improvements to AnalysisObject annotation handling in Python.

	* Adding rescaling arguments to yodamerge (and scale function to Python Scatter2D).

	* Better documentation and consistency of Histo and Profile Python
	wrappers, and removing some inappropriate attributes.

	* Adding clone() and newclone() functions to all analysis object classes.

2014-02-28  Andy Buckley  <andy.buckley@cern.ch>

	* Cython mapping improvements, esp. adding numPoints/numBins
	functions and better Scatter2D __repr__.

	* Adding mapping of the mkScatter functions into Python (as
	methods on Histo1D and Profile1D rather than the original free
	functions, at least for now: some Python type-identifying
	boilerplate is needed to make a single mkScatter function work in
	Python)

2014-02-27  Leif Lönnblad  <Leif.Lonnblad@thep.lu.se>

	* Minor modifications to BinSearcher to avoid NaN's. The NaN's
	were treated correctly before, but better to avoid them all
	together.

2014-02-27  Andy Buckley  <andy.buckley@cern.ch>

	* Adding the generated pyext/yoda/rootcompat.cpp to the tarball
	and sorting out the ROOT/Cython interface conditionals a bit more
	sanely. Thanks to Oldrich Kepka for the bug report.

	* Protecting yodamerge against input histograms with zero
	integrals (thanks to Christian Bierlich for the bug report).

2014-02-14  Frank Siegert  <frank.siegert@cern.ch>

	* Fix race condition with mktemplates.

2014-02-12  David Grellscheid  <david.grellscheid@dur.ac.uk>

	* Fix bug in mktemplates code (thanks to Christian Johnson for the bug report).

2014-02-09  Andy Buckley  <andy.buckley@cern.ch>

	* Adding explicit include/generated dir creation to Python
	extension build (thanks to Christian Johnson for the bug report).

2014-02-06  Andy Buckley  <andy.buckley@cern.ch>

	* 1.0.5 release!

2014-02-05  Andy Buckley  <andy.buckley@cern.ch>

	* Adding patches to ReaderFLAT and ReaderYODA use of Boost Spirit
	which reduce the Boost version requirement from 1.47 ->
	1.41. Thanks to Andrii Verbytskyi for the patch.

	* Protect against invalid prefix value if the --prefix configure option is unused.

2014-02-04  Andy Buckley  <andy.buckley@cern.ch>

	* Adding copy assignment operators where missing, based on an
	implementation in AnalysisObject which only copies rvalue paths
	and titles if they are non-null.

2014-02-03  Andy Buckley  <andy.buckley@cern.ch>

	* Improving (i.e. increasing) bin edge overlap tolerance: 1e-10 relative was too tight.

2014-01-31  Andy Buckley  <andy.buckley@cern.ch>

	* Adding x/yMid etc. methods on Bin1D and 2D, and more related Python API improvements.

2014-01-28  Andy Buckley  <andy.buckley@cern.ch>

	* Adding missing fillBin methods to 1D and 2D Histo/Profile Python classes.

	* Fixed yodamerge default output file name treatment.

	* Avoid computing an unrecoverable error in Histo1D.__repr__

	* Clean-ups and API improvements in Python IO functions.

	* Adding more sumW,W2 and (eff)NumEntries attrs to Python objects.

2013-12-17  Andy Buckley  <andy.buckley@cern.ch>

	* Improved argument handling for x2y scripts.

2013-11-16  Andy Buckley  <andy.buckley@cern.ch>

	* Fix to build the Cython rootcompt extension .cpp on request.

2013-11-14  Andy Buckley  <andy.buckley@cern.ch>

	* Adding flags for the C++11 or C++0x standard if supported, cf. Rivet.

2013-10-24  Andy Buckley  <andy.buckley@cern.ch>

	* YODA 1.0.4 release.

	* Supporting zsh completion via bash completion compatibility.

2013-10-21  Andy Buckley  <andy.buckley@cern.ch>

	* Removing unused internal iterator typedefs from Writer functions.

2013-10-18  Andy Buckley  <andy.buckley@cern.ch>

	* Adding a yodaenv.sh sourceable script to help with environment setup.

	* Remove Scatters from being handled by yodamerge by blocking the
	__add__ method fallback.

2013-10-09  Andy Buckley  <andy.buckley@cern.ch>

	* Improvements to yoda-config and command-line completion, for the
	Rivet 2.0.0 release.

2013-10-09  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.0.3 release.

2013-10-04  Andy Buckley  <andy.buckley@cern.ch>

	* Cython mapping improvements.

	* Adding some improved heuristics and a --normalize-all option to
	yodamerge. Frank S is now happy again ;-)

2013-10-01  Andy Buckley  <andy.buckley@cern.ch>

	* Adding operator +, -, +=, -= Python mappings wherever possible
	for Histo1/2D, Profile1/2D, and Scatter2D.

2013-09-26  Andy Buckley  <andy.buckley@cern.ch>

	* Cython is no longer needed by tarball users.

2013-09-25  Andy Buckley  <andy.buckley@cern.ch>

	* Unset path of returned histogram if those of the args to add()
	and subtract() are difference.

2013-09-24  Andy Buckley  <andy.buckley@cern.ch>

	* Python mapping improvements.

2013-09-23  Andy Buckley  <andy.buckley@cern.ch>

	* Add the -avoid-version flag to libtool.

	* Adding more add and subtract special methods in Python.

2013-09-22  Andy Buckley  <andy.buckley@cern.ch>

	* mkScatter schanged to use histo midpoints rather than focuses by
	default for the point x value.

2013-08-14  Andy Buckley  <andy.buckley@cern.ch>

	* Version 1.0.2.

	* Some exception message improvements and improving the protection
	of cosmetic mean calculations in WriterYODA.

2013-07-12  Andy Buckley  <andy.buckley@cern.ch>

	* Adding ROOT detection in configure and otherwise updating Dave's
	rootcompat module so that it'll compile. There might be an
	inconvenient ROOT version dependency in the signature of one of
	the PyROOT API functions that is used as a shim :-(

2013-06-17  Andy Buckley  <andy.buckley@cern.ch>

	* Adding yoda.m4 from James Robinson.

2013-06-06  Hendrik Hoeth  <hendrik.hoeth@cern.ch>

	* Improve "==" operator in Axis1D and Axis2D

2013-06-06  Andy Buckley  <andy.buckley@cern.ch>

	* Adding fillBin() methods to all 1D and 2D histos, and noting
	that Bin types need a back-link to their axis to maintain
	consistency.

	* Release of version 1.0.1

2013-06-05  Andy Buckley  <andy.buckley@cern.ch>

	* Change the divide(Scatter, Scatter) behaviours to use the
	midpoint of the num/denom bins rather than mean of foci for the
	output point position (and hence errors, too).

	* Adding a toIntegralEfficiencyHisto function.

	* Adding another Histo1D::integral() function, this time from 0 ->
	i, maybe including the underflow.

2013-06-04  Andy Buckley  <andy.buckley@cern.ch>

	* Updating the Cython version requirement to 0.18

2013-06-03  Andy Buckley  <andy.buckley@cern.ch>

	* Adding relErr functions to 1D and 2D histo and profile bins, and
	being careful about div by zero.

	* Improvements in error treatment in division (better handling of zeros).

	* Renaming merge-histos to yodamerge and installing it (and
	improving the usage string a bit).

2013-05-31  Andy Buckley  <andy.buckley@cern.ch>

	* Adding the Counter type, and ability to output it from the YODA writer.

	* Adding numEntries and effNumEntries methods to 1D and 2D Histo
	and Profile classes.

	* Adding Dbn0D and using it to implement Dbn1D.

2013-05-30  Andy Buckley  <andy.buckley@cern.ch>

	* Fixing several nasty errors in argument ordering for
	Point{1,2,3}D construction in Scatter addPoint functions.

	* Adding abs(...) to the returned Dbn1D::variance(), to avoid
	problems when negative weights produce negative variance. No, we
	don't like this either: is there a more correct way?

	* Fixing the efficiency(Histo1D, Histo1D) implementation,
	cf. http://root.cern.ch/phpBB3/viewtopic.php?t=3753

	* Adding mkScatter(Profile2D)

2013-05-29  Hendrik Hoeth  <hendrik.hoeth@cern.ch>

	* Adding a reader for FLAT files and a flat2yoda converter

2013-05-27  Andy Buckley  <andy.buckley@cern.ch>

	* Adding a yoda-completion file for bash.

2013-05-17  Andy Buckley  <andy.buckley@cern.ch>

	* Mapping HistoBin1D.relErr in Python.

	* Adding a non-const points() accessor to Scatter2D.

2013-05-13  Andy Buckley  <andy.buckley@cern.ch>

	* Adding combined value+error setX/Y functions on Point2D.

	* Adding HistoBin1D::relErr()

2013-04-23  Andy Buckley  <andy.buckley@cern.ch>

	* Adding Python output handling for single AOs and to be able to
	use a "-" filename to mean stdout.

2013-04-12  Andy Buckley  <andy.buckley@cern.ch>

	* Releasing version 1.0.0 -- it seems stable enough.

2013-04-10  Andy Buckley  <andy.buckley@cern.ch>

	* Being more careful about adding -Wno-* flags to the C++ compiler
	used to built the Cython extension lib.

2013-03-22  Andy Buckley  <andy.buckley@cern.ch>

	* Removing the use of svn:external to pull in Boost macros and
	using a minimal local set instead.

	* Using the nice Boost-finding macros from
	https://github.com/tsuna/boost.m4 and tidying up configure.ac

2013-03-15  Andy Buckley  <andy.buckley@cern.ch>

	* Re-organising the C++ side of the auto-format I/O functions,
	into a new IO header and separated from the Reader.h and
	Writer.h. I'm tempted to say that users shouldn't really NEED to
	ever directly touch the Reader and Writer objects...

	* Adding auto-format read and write functions. I will probably
	change the API. Python mappings have been provided, but the string
	workarounds were too much of a pain with Cython 0.16 so I have
	updated the Cython version requirement to 0.17 where it is
	automatic and hence much cleaner.

2013-03-08  Andy Buckley  <andy.buckley@cern.ch>

	* Making the x2y converter scripts write a copy into the *current*
	directory if only the input is specified.

2013-03-05  Andy Buckley  <andy.buckley@cern.ch>

	* Removing Plot entirely from YODA: it was an anomaly only added
	to make plot file generation easy, but this is now done better via
	StringIO (in new compare-histos/rivet-cmphistos).

	* Removing the Plot from Cython... and soon from YODA itself:
	we'll do this stuff manually and less hackily.

	* Make Cython automatically add a copy of the original call
	signature to each function's docstring.

2013-03-04  Andy Buckley  <andy.buckley@cern.ch>

	* Adding Plot mapping to Cython and improving the AO annotations handling in Python.

	* Adding PLOT section writing to WriterFLAT (and WriterYODA,
	although that might be a bad idea...)

	* Adding aida2yoda and aida2flat converter scripts.

2013-02-02  David Mallows  <dave.mallows@gmail.com>

	* Adding support for Python >= 2.4 (was Python >= 2.6)

	* Fixing miscellaneous warnings on GCC 4.1

2013-01-30  Andy Buckley  <andy.buckley@cern.ch>

	* Adding a points() method to the Python Scatter2D wrapper.

	* Adding a virtual destructor to Bin.

2012-12-30  Andy Buckley  <andy.buckley@cern.ch>

	* Adding support for Boost.Range arguments and file format autodetection in Writer.

2012-11-24  Andy Buckley  <andy.buckley@cern.ch>

	* Bump version to 0.6beta0

	* Adding more ROOT converters. Who knows how to make TProfiles
	from scratch, but Histo1D and Scatter2D are covered, which should
	be enough to get started with, at least.

2012-11-16  Andy Buckley  <andy.buckley@cern.ch>

	* Adding yoda-config

2012-11-16  Hendrik Hoeth  <hendrik.hoeth@cern.ch>

	* Adding WriterFLAT and yoda2flat

2012-11-16  Andy Buckley  <andy.buckley@cern.ch>

	* Adding YODA/ROOTCnv.h. for data object converter functions. Two
	(untested) functions added for TH1 -> YODA.

	* Adding toIntegralHisto(Histo1D&) function.

2012-11-15  Dave Mallows  <dave.mallows@gmail.com>

	* Commited numerous changes to Axis2D. Axis2D now uses BinSearcher as
	with Axis1D.

2012-11-15  Andy Buckley  <andy.buckley@cern.ch>

	* Improving division and efficiency treatments, and allowing
	arbitrary f(x), f(y), and flip transformations on Scatter2D.

2012-11-14  Andy Buckley  <andy.buckley@cern.ch>

	* Converting linspace, logspace, and their usage to place the nbins argument first.

2012-08-07  Andy Buckley  <andy.buckley@cern.ch>

	* Removing unused (beyond 2nd order) sumWXYZ counter from Dbn3D.

2012-08-07  Dave Mallows  <dave.mallows@gmail.com>

	* Converted Axis1D to use new Utils/BinSearcher.

2012-08-02  Dave Mallows  <dave.mallows@gmail.com>

	* Heavily refactored Cython bindings

	* HistoBin1D, ProfileBin1D etc. now inherit from Bin1D[DBN]

	* Temporarily removed Histo2D, Profile2D and Scatter3D mappings.

2012-07-23  Andy Buckley  <andy.buckley@cern.ch>

	* Installing scripts from bin dir, and making the yoda2aida interface nicer.

	* Adding Cython mappings for Dbn3D and Profile2D, and other fixes/improvements.

2012-07-22  Andy Buckley  <andy.buckley@cern.ch>

	* Adding Cython mappings for Scatter3D and ProfileBin2D.

	* Fixing more crap code legacy from old 2D plot implementation, this time in Scatter3D.

2012-07-19  Andy Buckley  <andy.buckley@cern.ch>

	* Adding stdErr for Histo2D + Python mapping, and more Cython improvements.

	* Adding path/title-only AO constructors and making nice Python constructor for Histo2D.

	* Cython mapping improvements & additions for Point3D + Scatter3D.

	* Removing mixed symm/asymm constructors on Point*D & Scatter*D classes.

2012-07-12  Andy Buckley  <andy.buckley@cern.ch>

	* Reintroducing Profile2D and Scatter3D.

	* Adding axis locking to Axis2D.

	* Supporting Histo2D in WriterYODA.

2012-07-02  Andy Buckley  <andy.buckley@cern.ch>

	* More incremental progress toward a working 2D bin hash mechanism.

2012-05-03  Andy Buckley  <andy.buckley@cern.ch>

	* Adding nice constructor behaviours to the Histo1D and Profile2D
	Python interfaces, and adding the mkScatter operation for
	Profile1D.

	* Adding more default constructors for analysis objects, to allow
	member variable and STL container use without pointers.

2012-05-02  Andy Buckley  <andy.buckley@cern.ch>

	* A much simplified and more robust rewrite of the Axis1D class,
	just using STL map in place of the hand-written bin edge caching.

	* Improvements (I hope) to the binary search in Axis1D, and
	providing an experimental default constructor for Histo1D.

2011-12-08  Hendrik Hoeth  <hendrik.hoeth@cern.ch>

	* ReaderYODA can now parse Histo1D and Profile1D flat files

2011-12-08  Andy Buckley  <andy.buckley@cern.ch>

	* Adding a Utils::ndarray object and using it to implement a
	general Scatter<N> system, with generalised Point<N> and Error<N>
	to boot.

2011-12-07  Hendrik Hoeth  <hendrik.hoeth@cern.ch>

	* Lots of cleanup

2011-12-07  Andy Buckley  <andy.buckley@cern.ch>

	* Mapping the Dbn1D and Dbn2D classes into Python.

	* Adding an outflows() accessor to Histo2D.

	* Writing out total dbn lines for Histo1D and Profile1D in the
	YODA format, and now writing out the 'cross-terms' for Profile1D,
	too.

	* Properly adding Dbn1D accessors for Histo1D.

	* Updating the Cython mappings to provide the totalDbn() methods
	and add a placeholder mapping for Dbn2D. Completed mappings are
	needed for Dbn{1,2,3}D and the Profile types.

	* Adding totalDbn() accessors to data types.

2011-12-06  Andy Buckley  <andy.buckley@cern.ch>

	* Making Histo1D/2D::scaleW() write a ScaledBy annotation.

	* Adding annotation-fetching methods with a default return value
	argument to AnalysisObject.

	* Adding normalize() methods to Histo1D/2D.

	* Adding weighted RMS calculating methods to Dbn1D, Dbn2D and
	Bin1D/2D.

2011-09-03  Dave Mallows  <dave.mallows@gmail.com>

	* Fixed ReaderAIDA: x-value and low y-error interchanged when filling
	Scatter2D.

	* Changed to Cython for Python bindings: Swig bindings were in need of
	serious amounts of work. Cython should provide a means to provide more
	Pythonic bindings to YODA. A minimal subset of ReaderAIDA, Scatter2D
	and Point2D have been wrapped.

	* Modified configure.ac, Makefile.am and pyext/Makefile.am to reflect
	change to Cython. Added cython.m4 from python-efl (Part of the
	enlightenment project; LGPL)

2011-08-31  Dave Mallows  <dave.mallows@gmail.com>

	* Fixed python tests by installing python extension to pyext/build

2011-08-23  Andy Buckley  <andy@insectnation.org>

	* Adding rebinning interface to Histo1D and Profile1D, and adding
	a test (and a new test feature for output message formatting)

	* Adding first implementation of 1D bin merging to Axis1D.

2011-08-22  Andy Buckley  <andy@insectnation.org>

	* Adding copy constructors and assignment operators to Histo1D,
	Profile1D, and Scatter2D, and their respective bins/points.

	* Remove use of sign(weight) in filling sum(w2) -- I think this
	was an historical attempt based on a scaling axiom which turned
	out to be inappropriate.

	* Reworking the Bin1D inheritance and composition design so that
	all bin types store a single distribution object -- a Dbn1D for
	histo bins and a Dbn2D for profile bins.

2011-08-18  Andy Buckley  <andy@insectnation.org>

	* Removing the Profile1D -> ProfileBin1D friendship. This is very
	heartening -- the fewer friend declarations we need, the more
	indication that the class structure is not pathological! (Or that
	we've just made everything public... but we haven't)

2011-08-15  Andy Buckley  <andy@insectnation.org>

	* Inlining all functions in HistoBin1D, ProfileBin1D, and
	HistoBin2D.

	* Converting Dbn2D to be composed of two Dbn1Ds and a
	cross-term. Also tidying the interfaces of the 2D classes and the
	scaleX/Y methods throughout, and adding Doxygen comments.

2011-08-12  Andy Buckley  <andy@insectnation.org>

	* Adding proper Doxygen structures and full descriptive comments
	to Dbn2D.

	* Adding the persistency state-setting constructors for Profile1D
	and Dbn2D.

	* Inlining lots of methods on Dbn1D. Same should be done for
	Dbn2D, but first it needs to be reimplemented in terms of two
	Dbn1Ds + the cross-term.

2011-08-11  Andy Buckley  <andy@insectnation.org>

	* Various typo fixes and comments relating to persistency
	constructors, Histo2D slicing, etc.

	* Changing the HistoBin1D state-setting constructors (aargh, these
	should *not* have already existed) to take Dbn1D as an argument
	rather than a long list of doubles.

2011-08-01  Andy Buckley  <andy@insectnation.org>

	* Adding tests to check that implicit construction of Weights
	objects from literal doubles and ints works.

2011-07-28  Andy Buckley  <andy@insectnation.org>

	* Bumping version number to 0.4.0beta0 -- there have been
	substantial changes recently and YODA is now in a state where it
	should be interesting for outsiders to start playing with it.

	* Templating the Axis1D on the distribution type to be used for
	total and under/overflow statistics: Profile1D now has Dbn2D
	objects handling its total and overflow statistics.

2011-07-26  Andy Buckley  <andy@insectnation.org>

	* Added a Histo1D::integral(index1, index2) method. Not sure how
	or if to extend this to Profile1D.

	* Implementing incomplete Scatter2D operator+ and operator-
	functions.

2011-07-25  Andy Buckley  <andy@insectnation.org>

	* Adding a Weights class, designed to seamlessly replace
	double-type weights and weighted moments with a named and
	vectorised form.

2011-07-19  Andy Buckley  <andy@insectnation.org>

	* Add Profile1D and Scatter2D division operators.

	* Add xMin/xMax synonyms to the Axis1D, cf. the bins.

2011-07-18  Andy Buckley  <andy@insectnation.org>

	* Add a first stab at a Histo1D/Histo1D division operator.

2011-07-10  Andy Buckley  <andy@insectnation.org>

	* Add construction of Histo1Ds from Profile1D and Histo1D, and
	construction of Profile1Ds from those and Scatter2D.

2011-07-07  Andy Buckley  <andy@insectnation.org>

	* Add construction of a Histo1D from Scatter2D.

2011-06-15  Andy Buckley  <andy@insectnation.org>

	* Making the AIDA reader work, including reading of annotations
	and a few tweaks to the simple type persistency system. Test histo
	1b updated.

2011-06-12  Andy Buckley  <andy@insectnation.org>

	* Removing Histo1D::area

	* Filling and using under/overflow and total db on Histo1D, and
	adding boolean arg to integral, sumW, etc.

	* Fixing for C++ change in behaviour of std::make_pair

	* Adding addAnnotation, and mapping annotations to Python.

2011-02-22  Andy Buckley  <andy@insectnation.org>

	* Use distutils rather than setuptools for the Python interface
	build.

	* Renaming Bin, HistoBin and ProfileBin to be Bin1D, HistoBin1D,
	ProfileBin1D. Bin is now a top-level abstract class with minimal
	functionality to be shared between 1D and 2D bins.

2011-01-12  Andy Buckley  <andy@insectnation.org>

	* Type annotations in mkScatter

	* Added many vector constructors and addPoint functions to
	Scatter2D.

2011-01-11  Andy Buckley  <andy@insectnation.org>

	* Add lexical_cast support to annotation get and set functions.

	* Write out annotations in AIDA format, and copy annotations in
	mkScatter -- using a new AnalysisObject::setAnnotations method.

	* Convert DPS output to use interim Scatter construction

	* Make (unused) yoda.plot subpackage.

	* Write out annotations in YODA format.

	* Make Scatter2D representations of Histo1D and Profile1D.

	* Write out Scatter2D objects in AIDA and YODA formats.

	* Make Scatter2D and Point2D work. Add a few extra
	methods... evolution and tweaking required.

2011-01-10  Andy Buckley  <andy@insectnation.org>

	* Add Boost checks and header includes. Not used yet.

	* Hide Utils:: content from Doxygen and nvector -> Utils::nvector.

	* Removing unused YAML stuff: we aren't going that way for
	persistency anymore.

	* Renaming Axis -> Axis1D

	* Removing dead-end templated Scatter stuff.

	* Move (generated) config files into the Config subdir.

	* Move sortedvector and indexedset into the Utils dir.

	* Move the "utils" directory and namespace to "Utils"

	* Put the Doxyfile under configure control by moving it to
	Doxyfile.in and using the @PACKAGE_VERSION@ token.

	* Make Doxygen find the .icc file and hide functions with name _*
	and in the YAML namespace.

	* Removing the Binning argument and enum in favour of explicit bin
	edge vectors, possibly produced explicitly via the MathUtils
	linspace and logspace functions, or the new Axis::mkBinEdgesLin/Log
	alias functions.

	* Fixed Axis, Histo1D and Profile1D constructors, by adding a path
	argument, passing the path and title args to the AnalysisObject
	base constructor properly.

	* Removed several old and unused files such as Tree.h

2011-01-09  Andy Buckley  <andy@insectnation.org>

	* Updating copyright comments to be valid into 2011.

	* Persistency fixes, and changing the interface to use the annotated path.

	* Using annotations for path and title.

	* Adding tests of collection and iterator range AO writing.

	* Adding static write functions on Writer*.h implementations to
	avoid needing to make an explicit Writer object via the create()
	functions.

	* Rename Exception.h -> Exceptions.h

	* Added AnnotationError.

	* Re-enable persistency of collections with begin/end iterators.

2011-01-08  Andy Buckley  <andy@insectnation.org>

	* Enabling quiet compilation.

	* More annotation functionality.

2011-01-07  Andy Buckley  <andy@insectnation.org>

	* Sorting out autoheaders to be more useful.

	* Rewriting AIDA writer to use DPS representation (no reloading)
	for Histo1D and Profile1D objects.

	* Adding persistency system hooks, since RTTI just sucks too much.

	* Renaming test files to have more meaningful names.

2010-12-10  Andy Buckley  <andy@insectnation.org>

	* Some tweaks to Axis, Bin, etc. to use the sortedvector. Seems to
	be working! (I must be checking it wrongly...)

	* Adding another candidate object for the axis bin container: a
	sorted extension to STL std::vector with an insert method. This
	will do as a development placeholder: a proper sorted & indexed
	container may be substituted later.

	* Fix test code: titles are no longer given as histogram
	constructor arguments.

2010-11-21  Andy Buckley  <andy@insectnation.org>

	* Adding indexed set for holding bins on axes. Still not sure it's
	what we want, as (I just realised) STL sets are iterator-immutable
	because they are self-keyed and changes to elements would also
	change their sorting.

2010-09-19  Andy Buckley  <andy@insectnation.org>

	* Restarting ChangeLog contributions! Many changes in the huge
	time since last update... activity on YODA has renewed and we have
	a better picture of the distinctive features we require. New idea:
	named weight vector filling, allowing "parallel" histograms for
	various event weight variations. I/O remains an awkward issue,
	especially since the classes are now much richer than they used to
	be, and don't know about paths. Output can be easily put on top:
	not an issue... and we can probably do something with
	pickling. But reading in from C++?

2008-09-16  Andy Buckley  <andy@insectnation.org>

	* Moved duplicate Histo1D/Profile1D code on to Axis, making Axis a
	templated class at the same time.

2008-09-12  Andy Buckley  <andy@insectnation.org>

	* Started work on a little plotting tool, initially for Herwig++
	parton pT cut testing, but incrementally enhancing it to be a
	command-line quick plotter seems like a good idea.

	* Added some more test programs... working towards a proper test
	suite.

	* Added "no path & title" constructors - you don't always want to
	write out the histo, since sometimes it's just a good way to
	gather statistics.

	* Fixed YODA mapping to allow use of vectors of bins as Python
	lists.

	* Added Profile1D functionality.

	* Fixed Dbn1D to use sign(weight) as part of the "w**2" measure,
	so that negative weights behave themselves.

2008-05-23  Andy Buckley  <andy@insectnation.org>

	* Added Dbn1D class to centralise the calculation of statistics
	from unbounded, unbinned, weighted distributions.

2008-05-15  Andy Buckley  <andy@insectnation.org>

	* Added Profile1D class.

	* Fixed NaN errors from zero weights.

2008-04-14  Andy Buckley  <andy@insectnation.org>

	* Python SWIG interface now compiles and can be used: the subtlety
	that was breaking it was that SWIG has to be prodded in pretty
	non-obvious ways to make std::vectors of classes without
	default (no-arg) constructors. See
	http://osdir.com/ml/programming.swig/2004-04/msg00011.html for
	about the only reference to this to be found anywhere!

	* Basic AIDA writer now available - it doesn't yet output all the
	necessary information though, especially not for merging parallel
	runs.
